-- thanks goes to creators of BigWigs_Plugins/bars.lua and Chronometer for some initial concept ideas
-- keep wowace alive, donate!
SpellReminder = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceHook-2.1", "AceConsole-2.0", "AceEvent-2.0", "FuBarPlugin-2.0", "Parser-3.0", "Sink-1.0")
local SpellReminder, self = SpellReminder, SpellReminder
SpellReminder.candybar = AceLibrary("CandyBar-2.0")
SpellReminder.sm = AceLibrary("SharedMedia-1.0")

SpellReminder:RegisterDB("SpellReminderDB","SpellReminderDBPerChar")
SpellReminder:RegisterDefaults('profile', {
--	startScale	= 1,
--	stopScale	= 1.5,
--	splitSelf	= false,
	ttg			= 0.3,
	disableEmphasis = false,
	lockbars	= false,
	debugmode	= false,
	-- output
	textWarnings	= "Both",
	audioWarnings	= "None",
	-- formatting
	textFormat	= "%t (%a) - %n",
	texture		= "Blizzard",
	baroverride	= false,
	barfont		= nil,
	barfontsize	= 11,
	barwidth	= 200,
	barheight	= 16,
	-- spellsetup
	disableDetection	= false,
	targetGroup_self	= 1,
	targetGroup_buff	= 1,
	targetGroup_debuff	= 1,
	defaultBarColor = {["r"] = 1, ["g"] = 0, ["b"] = 0, ["a"] = 1},
	--bargroups = {},
--	barposition	= { normal = {} , self = {} , emphasis = {} },
})
SpellReminder:RegisterDefaults('char', {
	spellSetup	= {},
	bargroups = {},
})

SpellReminder.hideWithoutStandby = true;
SpellReminder.hasNoColor = true;
SpellReminder.hasIcon = "Interface\\Icons\\Ability_Warrior_BattleShout"

SpellReminder.barTypes = { "self","buff","debuff" } --,"cooldown"}
SpellReminder.spellSuffixes = {""," Totem"," Weapon"}

SpellReminder.anchors = {}
SpellReminder.defaultBarGroup = { name="New Bar", growup = false, emphasise=true, position = {}, cantEdit = false, scale = 1, }

-- stores information PER SPELL[Target]
SpellReminder.spellTracker = {
	casting = {},
	active = {},
}

function SpellReminder:OnInitialize()
end

function SpellReminder:OnEnable()
    -- Called when the addon is loaded
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	self:RegisterEvent("UNIT_SPELLMISS")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
	self:RegisterEvent("PLAYER_DEAD")
	self:RegisterParserEvent({eventType = "Death"},"COMBAT_DEATH")

	
	self:RegisterEvent("SpecialEvents_UnitBuffLost","SE_AURA_LOST")
	self:RegisterEvent("SpecialEvents_PlayerItemBuffLost","SE_ITEM_AURA_LOST")
	
	self:RegisterEvent("UNIT_SPELLCAST_DELAYED",function(unit) if unit == "player" then self:ProcessAuras(unit) end end)

--	self:RegisterEvent("PLAYER_AURAS_CHANGED",function() self:ProcessAuras("player") end)
	self:RegisterEvent("PLAYER_TARGET_CHANGED",function() self:ProcessAuras("target") end)
	self:RegisterEvent("UNIT_AURA",function(unit) self:ProcessAuras(unit) end)
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT",function() self:ProcessAuras("mouseover") end)
--	self:RegisterEvent("UNIT_PET",function(unit) self:DebugPrint("Pet changed, rescanning") if unit == "player" then self:InstallAllSpells() end end)
	self:RegisterEvent("CHARACTER_POINTS_CHANGED","InstallAllSpells")
	self:RegisterEvent("LEARNED_SPELL_IN_TAB","InstallAllSpells")
--CHAT_MSG_SPELL_SELF_DAMAGE
	
	self.options = self:InitOptions()
	self.OnMenuRequest = self.options
--	self:RegisterChatCommand({'/SpellReminder'}, self.options)
	self:RegisterChatCommand('/SpellReminder', {
		type = 'execute',
		func = function()
			self:OpenMenu()
		end
	})
	
	self:CreateAnchors()
	
	self:ClearSpells(false)
	self:InstallAllSpells()
	self:RefreshSpellOptions()
end

function SpellReminder:GetEventName(spellName,targetName)
	return "DURATION_ENDING_"..spellName..";"..targetName , "CASTING_"..spellName..";"..targetName
end

function SpellReminder:ProcessAuras(unit)
	local targetName = UnitName(unit)
	if targetName == nil or targetName == "Unknown" then return end
	if UnitIsDead(unit) then return end
	local _,_,targetName = string.find(targetName,"([^-]+)")
	local hasAura = {}
	
	self:DebugPrint("ProcessAuras "..unit)
	local i = 1
	while UnitExists(unit) and (UnitBuff(unit, i) ~= nil) do
		local name, rank, iconTexture, applications, duration, timeLeft = UnitBuff(unit, i)
		local eventName = self:GetEventName(name,targetName)
		if duration ~= nil and duration >0 and timeLeft ~= nil and timeLeft > 0 then
			hasAura[name] = true
			local info = self.db.char.spellSetup[name]
			if info == nil and (self.db.profile.disableDetection == false) and duration ~= nil and duration > 0 then
				self:Print("Detected new spell! ("..name..")")
				self:InstallWatch(name,rank,nil,duration,iconTexture)
				info = self.db.char.spellSetup[name]
				if select(1,self:GetDuration(name,rank)) == nil then self.db.char.spellSetup[name].detected = true end
			end
			if duration == nil and unit == "player" then duration = self:GetPlayerBuffDuration(name) end
			if info ~= nil and info.active == true then --and duration ~= nil then
				self.db.char.spellSetup[name].icon = iconTexture
				if timeLeft ~= nil then
					local castingInfo = self.spellTracker.active[eventName]
					if not castingInfo then
						castingInfo = {n=name, displayName=info.displayName, barType="buff", icon=iconTexture, r=info.r, ["rank"]=rank, t=targetName, ["eventName"]=eventName, c=info.c}
					end
					castingInfo["applications"] = applications
--					castingInfo.canRemove = true
					self:CreateReminderBar(eventName, castingInfo, duration, info.r, info.c, timeLeft)
				else -- not your spell
					self:OnDurationEnded(eventName,true)
				end
			end
		end
		i = i + 1
	end
	
	local i = 1
	while UnitExists(unit) and (UnitDebuff(unit, i) ~= nil) do
		local name, rank, iconTexture, applications, debuffType, duration, timeLeft = UnitDebuff(unit, i)
		local eventName = self:GetEventName(name,targetName)
		if duration ~= nil and duration >0 and timeLeft ~= nil and timeLeft > 0 then
			hasAura[name] = true
			local info = self.db.char.spellSetup[name]
			if info == nil and (self.db.profile.disableDetection == false) and duration ~= nil and duration > 0 then
				self:Print("Detected new spell! ("..name..")")
				self:InstallWatch(name,rank,nil,duration,iconTexture)
				info = self.db.char.spellSetup[name]
				if select(1,self:GetDuration(name,rank)) == nil then self.db.char.spellSetup[name].detected = true end
			end
			if info ~= nil and info.active == true then --and duration ~= nil then
				self.db.char.spellSetup[name].icon = iconTexture
				if timeLeft ~= nil then
					local castingInfo = self.spellTracker.active[eventName]
					if not castingInfo then
						castingInfo = {n=name, displayName=info.displayName, barType="debuff", icon=iconTexture, r=info.r, ["rank"]=rank, t=UnitName(unit), ["eventName"]=eventName, c=info.c}
					end
					castingInfo["applications"]=applications
--					castingInfo.canRemove = true
					self:CreateReminderBar(castingInfo.eventName, castingInfo, duration, castingInfo.r, info.c, timeLeft)
				else -- not your spell
					self:OnDurationEnded(eventName,true)
				end
			end
		end
		i = i + 1
	end
	
	table.foreach(self.spellTracker.active, function (eventName,info)
--		self:Print("Checking for DontRemove "..info.t.."="..targetName.." and not "..(hasAura[info.n] and "true") or "false")
		if info.t == targetName and (not hasAura[info.n]) and (not info.persistent) then -- and (not info.DontRemove) then -- call OnDurationEnded
	--		self:Print("Dont Remove: "..info.n)
	--		self.spellTracker.active[eventName].DontRemove = true
			self:OnDurationEnded(eventName,true)
		end
	end)

	if unit ~= "player" or true then return end -- not yet working, break out
	hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo()
	if hasMainHandEnchant then
		_, textureName = GetInventorySlotInfo("MainHandSlot")
		castingInfo = {n="MH Buff", displayName="MH Buff", icon=textureName, ["applications"]=mainHandCharges, r=mainHandExpiration*0.125, t=UnitName(unit), eventName="DURATION_ENDING_"..name..";"..UnitName(unit)}
		self.spellTracker.active[castingInfo.eventName] = castingInfo
		self:CreateReminderBar(castingInfo.eventName, castingInfo, mainHandExpiration, castingInfo.r, nil, mainHandExpiration)
	end
	if hasOffHandEnchant then
		_, textureName = GetInventorySlotInfo("SecondaryHandSlot")
		castingInfo = {n="OH Buff", displayName="OH Buff", icon=textureName, ["applications"]=offHandCharges, r=offHandExpiration*0.125, t=UnitName(unit), eventName="DURATION_ENDING_"..name..";"..UnitName(unit)}
		self.spellTracker.active[castingInfo.eventName] = castingInfo
		self:CreateReminderBar(castingInfo.eventName, castingInfo, offHandExpiration, castingInfo.r, nil, offHandExpiration)
	end
end
--[[function SpellReminder:ProcessAuras()
	self:DebugPrint("ProcessAuras")
	i = 1
	while (GetPlayerBuff(i,"HELPFUL") > 0) do
		buffIndex, untilCancelled =  GetPlayerBuff(i,"HELPFUL")
		name, texture, applications, timeLeft = GetPlayerBuffName(buffIndex), GetPlayerBuffTexture(buffIndex), GetPlayerBuffApplications(buffIndex), GetPlayerBuffTimeLeft(buffIndex)
		duration = self:GetPlayerBuffDuration(name)
		local info = self.db.char.spellSetup[name]
		if info ~= nil and info.active == true and duration ~= nil then
			castingInfo = {n=name, displayName=info.displayName, r=info.r, ["rank"]=rank, t=UnitName("player"), eventName="DURATION_ENDING_"..name..";"..UnitName("player"), c=info.c}
			self.spellTracker.active[castingInfo.eventName] = castingInfo
			self:CreateReminderBar(castingInfo.eventName, castingInfo, duration, info.r, info.c, timeLeft)
		end
		i = i + 1;
	end
end]]

function SpellReminder:PLAYER_LOGIN()
	self:CheckNonFade()
	self:ProcessAuras("player")
	self:ProcessAuras("pet")
--	self:ScheduleEvent(self.ProcessAuras,0.5,self,"player")
--	self:ScheduleEvent(self.CheckNonFade,5,self)
end

function SpellReminder:CheckNonFade()
	foreach(self.db.char.spellSetup,function (spellName,info)
		if info.fade == -1 and not self:BarExists(spellName) then
			local duration, rank = self:GetDuration(spellName)
			local castingInfo = {n=spellName, displayName=info.displayName, barType="buff", icon=info.icon, ["applications"]=0, r=info.r, ["rank"]=rank, t=UnitName("player"), eventName="DURATION_ENDING_"..spellName..";"..UnitName("player"), c=info.c}
			self:CreateReminderBar(castingInfo.eventName, castingInfo, duration or 120, info.r, info.c, 0)
		end
	end)
end
	
function SpellReminder:OnDisable()
--[[
    -- Called when the addon is disabled
	self:UnregisterEvent("PLAYER_LOGIN")
	self:UnregisterEvent("UNIT_SPELLCAST_SENT")
	self:UnregisterEvent("UNIT_SPELLCAST_STOP")
	self:UnregisterEvent("UNIT_SPELLMISS")
	self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:UnregisterEvent("PLAYER_DEAD")
	self:UnregisterParserEvent({eventType = "Death"},"COMBAT_DEATH")

	
	self:UnregisterEvent("SpecialEvents_UnitBuffLost","SE_AURA_LOST")
	self:UnregisterEvent("SpecialEvents_PlayerItemBuffLost","SE_ITEM_AURA_LOST")

	self:UnregisterEvent("PLAYER_AURAS_CHANGED",function() self:ProcessAuras("player") end)
	self:UnregisterEvent("PLAYER_TARGET_CHANGED",function() self:ProcessAuras("target") end)
	self:UnregisterEvent("UNIT_AURA",function(unit) self:ProcessAuras(unit) end)
	self:UnregisterEvent("UNIT_PET",function(unit) self:DebugPrint("Pet changed, rescanning") if unit == "player" then self:InstallAllSpells() end end)
	self:UnregisterEvent("CHARACTER_POINTS_CHANGED","InstallAllSpells")
	self:UnregisterEvent("LEARNED_SPELL_IN_TAB","InstallAllSpells")

	-- stop all spell watch events
--	table.foreach(self.db.char.spellSetup, function(k,v) self:CancelWatchSpell(k) end)
	candybar:UnregisterCandyBarGroup("SpellReminderNormal")
	candybar:UnregisterCandyBarGroup("SpellReminderEmphasis")
	]]
end

function SpellReminder:AddNewAnchor(overrideProperties,dontCreate)
	local newGroup = tcopy(SpellReminder.defaultBarGroup)
	if overrideProperties == nil then return newGroup end
	-- need to override
	table.foreach(overrideProperties, function (k,v) newGroup[k] = v end)
	
	table.insert(SpellReminder.db.char.bargroups,newGroup)
	if not dontCreate then
		self:CreateAnchors()
	end
	
	return # SpellReminder.db.char.bargroups
end

function SpellReminder:GetAnchorByIdent(val)
	for k,anchor in ipairs(SpellReminder.db.char.bargroups) do
		if anchor.ident == val then return k end
	end
	return nil
end

function SpellReminder:CreateAnchors()
	if self:GetAnchorByIdent("normal") == nil then
		self:AddNewAnchor({ ident="normal",		name="Normal",		cantEdit=true, position=(self.db.profile.barposition and self.db.profile.barposition["normal"]) or {}, },true)
	end
	if self:GetAnchorByIdent("emphasis") == nil then
		self:AddNewAnchor({ ident="emphasis",	name="Emphasis",	cantEdit=true, position=(self.db.profile.barposition and self.db.profile.barposition["emphasis"]) or {}, },true)
	end
	
	self.db.profile.barposition = nil
	self.db.profile.splitSelf = nil
	
	if SpellReminder.db.profile.bargroups ~= nil then
		SpellReminder.db.char.bargroups = tcopy(SpellReminder.db.profile.bargroups,SpellReminder.db.char.bargroups)
		SpellReminder.db.profile.bargroups = nil
	end

	table.foreach(SpellReminder.db.char.bargroups, function (i,groupinfo)
		if groupinfo == nil then self.db.char.bargroups[i] = nil return end
		self.anchors[i] = tcopy(groupinfo,self.anchors[i])
		if self.anchors[i].frame ~= nil then self.anchors[i].frame.Text:SetText(self.anchors[i].name) return end
		self.anchors[i].frame = self:CreateAnchor(i,groupinfo.name,0.3,1,0.3)
		self.candybar:RegisterCandyBarGroup("ReminderCandy_"..i)
		self.candybar:SetCandyBarGroupPoint("ReminderCandy_"..i, "TOP", self.anchors[i].frame, "BOTTOM", 0, 0)	
		self.candybar:SetCandyBarGroupGrowth("ReminderCandy_"..i, (self.db.char.bargroups[i] and self.db.char.bargroups[i].growup) or false)
	end)
	self:RefreshBarGroupList()
	self:RefreshGroupOptions()
	self:RefreshSpellOptions()
--	self.normalAnchor = self:CreateAnchor("normal","Normal/Target Bars",0.3,1,0.3)
--	self.selfAnchor = self:CreateAnchor("self","Self cast Bars",0.3,1,0.3)
--	self.emphasisAnchor = self:CreateAnchor("emphasis","Emphasised Bars",0.3,1,0.3)

	-- setup candybar
--	candybar:RegisterCandyBarGroup("SpellReminderNormal")
--	candybar:SetCandyBarGroupPoint("SpellReminderNormal", "TOP", self.normalAnchor, "BOTTOM", 0, 0)	
--	candybar:SetCandyBarGroupGrowth("SpellReminderNormal", getOption("growup"))
	
--	candybar:RegisterCandyBarGroup("SpellReminderSelf")
--	candybar:SetCandyBarGroupPoint("SpellReminderSelf", "TOP", self.selfAnchor, "BOTTOM", 0, 0)	
--	candybar:SetCandyBarGroupGrowth("SpellReminderSelf", getOption("growup"))
	
--	candybar:RegisterCandyBarGroup("SpellReminderEmphasis")
--	candybar:SetCandyBarGroupPoint("SpellReminderEmphasis", "TOP", self.emphasisAnchor, "BOTTOM", 0, 0)	
--	candybar:SetCandyBarGroupGrowth("SpellReminderEmphasis", getOption("growup"))

	self:ToggleAnchors()
end

function SpellReminder:ResetAnchors()
	self.db.char.bargroups = {}
	self:CreateAnchors()
	
	if not self.db.profile.lockbars then self:ToggleAnchors() end
	local s = this:GetEffectiveScale()
	table.foreach(self.anchors, function (i,anchor)
		anchor.frame:ClearAllPoints()
		anchor.frame:SetPoint("CENTER", 0, 50 /s)
	end)
--	self.normalAnchor:ClearAllPoints()
--	self.normalAnchor:SetPoint("CENTER", 0, 50 /s)
--	self.selfAnchor:ClearAllPoints()
--	self.selfAnchor:SetPoint("CENTER", 0, 0)
--	self.emphasisAnchor:ClearAllPoints()
--	self.emphasisAnchor:SetPoint("CENTER", 0, 150 /s)
	self:SaveAnchorPositions()
end

function SpellReminder:ToggleAnchors()
	if self.db.profile.lockbars then
		table.foreach(self.anchors, function (i,anchor)
			anchor.frame:Hide()
		end)
--		self.normalAnchor:Hide()
--		self.selfAnchor:Hide()
--		self.emphasisAnchor:Hide()
	else
		table.foreach(self.anchors, function (i,anchor)
			anchor.frame:Show()
		end)
--		self.normalAnchor:Show()
--		self.selfAnchor:Show()
--		self.emphasisAnchor:Show()
	end
end

function SpellReminder:SaveAnchorPositions()
--	local s = this:GetEffectiveScale()
	table.foreach(self.anchors, function (i,anchor)
		local point, _, anchor, x, y = self.anchors[i].frame:GetPoint()
		self.db.char.bargroups[i].position.x = x --* s
		self.db.char.bargroups[i].position.y = y --* s
		self.db.char.bargroups[i].position.anchor = anchor
		self.db.char.bargroups[i].position.point = point
	end)
	--[[
	local point, _, anchor, x, y = self.normalAnchor:GetPoint()
	self.db.profile.barposition["normal"].x = x * s
	self.db.profile.barposition["normal"].y = y * s
	self.db.profile.barposition["normal"].anchor = anchor
	self.db.profile.barposition["normal"].point = point
	
	local point, _, anchor, x, y = self.selfAnchor:GetPoint()
	self.db.profile.barposition["self"].x = x * s
	self.db.profile.barposition["self"].y = y * s
	self.db.profile.barposition["self"].anchor = anchor
	self.db.profile.barposition["self"].point = point
	
	local point, _, anchor, x, y = self.emphasisAnchor:GetPoint()
	self.db.profile.barposition["emphasis"].x = x * s
	self.db.profile.barposition["emphasis"].y = y * s
	self.db.profile.barposition["emphasis"].anchor = anchor
	self.db.profile.barposition["emphasis"].point = point
	]]
end

function SpellReminder:CreateAnchor(name, text, cRed, cGreen, cBlue)
	local f = CreateFrame("Button", "SpellReminder_"..name.."Anchor", UIParent)
	f:SetWidth(200)
	f:SetHeight(25)

	f.owner = self

--	local s = this:GetEffectiveScale()
	f:ClearAllPoints()
	if self.db.profile.barposition ~= nil and self.db.profile.barposition[name] ~= nil then -- updates all the old storage methods into the new tables
		self.db.char.bargroups[name] = tcopy(self.db.profile.barposition[name],self.db.char.bargroups[name])
		self.db.profile.barposition[name] = nil
	end
	if self.db.char.bargroups[name] and self.db.char.bargroups[name].position and self.db.char.bargroups[name].position.x and self.db.char.bargroups[name].position.y and self.db.char.bargroups[name].position.point and self.db.char.bargroups[name].position.anchor then
		f:SetPoint(self.db.char.bargroups[name].position.point, UIParent, self.db.char.bargroups[name].position.anchor, self.db.char.bargroups[name].position.x, self.db.char.bargroups[name].position.y)
--		f:SetPoint(self.db.char.bargroups[name].position.point, UIParent, self.db.char.bargroups[name].position.anchor, self.db.char.bargroups[name].position.x/s, self.db.char.bargroups[name].position.y/s)
	else
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 50)--/s)
	end

	f:SetScript("OnDragStart", function() this:StartMoving() end )
	f:SetScript("OnDragStop",
		function()
			this:StopMovingOrSizing()
			self:SaveAnchorPositions()
        end)

	f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                                            tile = false, tileSize = 16, edgeSize = 16,
                                            insets = { left = 5, right =5, top = 5, bottom = 5 }})
	f:SetBackdropColor(cRed,cGreen,cBlue,.6)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")

	f.Text = f:CreateFontString(nil, "OVERLAY")
	f.Text:SetFontObject(GameFontNormalSmall)
	f.Text:ClearAllPoints()
	f.Text:SetTextColor(1, 1, 1, 1)
	f.Text:SetWidth(200)
	f.Text:SetHeight(25)
	f.Text:SetPoint("TOPLEFT", f, "TOPLEFT")
	f.Text:SetJustifyH("CENTER")
	f.Text:SetJustifyV("MIDDLE")
	f.Text:SetText(text)

	f:Hide()

	return f
end

function SpellReminder:CreateTestBars()
	local i
	for i=1, 5 do
		if math.random()>0.5 then -- debuff
			self:CreateReminderBar("TEST_MANUAL_"..i,{n="Test "..i,t="Enemy "..i,barType="debuff"}, i*5, i*2,{r=math.random(),g=math.random(),b=math.random()})
		else
			local pseudoTarget = (math.random() > 0.5 and UnitName("player")) or "Friendly "..i
			self:CreateReminderBar("TEST_MANUAL_"..i,{n="Test "..i,t=pseudoTarget,barType="buff"}, i*5, i*2,{r=math.random(),g=math.random(),b=math.random()})
		end
	end
end

function SpellReminder:ClearSpells(clearAll)
	table.foreach(self.db.char.spellSetup, function (spellName,info)
		if (clearAll == true) then self:ClearSpell(spellName) return end
		if (info.detected == true) then return end
		--self.db.char.spellSetup[spellName] = nil
		local found = false
		local i = 1
		while true do
			local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
			if (not spell) then	break end
			if spell == spellName then
				found = true
			end
			i = i + 1
		end
		
	--[[	local i = 1
		while true do
			local spell, rank = GetSpellName(i, BOOKTYPE_PET)
			if (not spell) then	break end
			if spell == spellName then
				found = true
			end
			i = i + 1
		end]]
		if found == false then self:ClearSpell(spellName) end
	end)
	
	self:RefreshSpellOptions()
end

function SpellReminder:ClearSpell(spellName)
	self.db.char.spellSetup[spellName] = nil
	self.options.args.spells.args["spell_"..string.gsub(spellName," ","_")] = nil
end

function SpellReminder:InstallWatch(spellName,rank,reminder,duration,icon)--,sharedName,reminder)
	if duration == nil then
		duration, rank = self:GetDuration(spellName,rank)
	end
	if duration == nil then return end -- this can happen if the spell isnt available on this character

--	self:DebugPrint("Adding spell: "..spellName)
	if self.db.char.spellSetup[spellName] == nil then self.db.char.spellSetup[spellName] = {} end
	if (self.db.char.spellSetup[spellName].active == nil) then
		self.db.char.spellSetup[spellName].active = true
	end
	--self.db.char.spellSetup[spellName].s		= self.db.char.spellSetup[spellName].s or sharedName or spellName
	self.db.char.spellSetup[spellName].displayName = self.db.char.spellSetup[spellName].displayName or spellName
	self.db.char.spellSetup[spellName].rank		= rank
	
	if icon == nil then icon = self:GetTexture(spellName) end
	if icon ~= nil then self.db.char.spellSetup[spellName].icon = icon end
	
	if self.db.char.spellSetup[spellName].d == nil or duration > self.db.char.spellSetup[spellName].d then
		self.db.char.spellSetup[spellName].d	= duration
		local defaultReminder = math.ceil(duration*0.125)
		if defaultReminder < 5 and duration > 5 then defaultReminder = 5 end
		if defaultReminder > 30 then defaultReminder = 30 end
		self.db.char.spellSetup[spellName].r	= self.db.char.spellSetup[spellName].r or reminder or defaultReminder
--[[		if durationDebuff ~= nil then
			local defaultReminder = math.ceil(durationDebuff*0.125)
			if defaultReminder < 5 and durationBuff > 5 then defaultReminder = 5 end
			if defaultReminder > 30 then defaultReminder = 30 end
			self.db.char.spellSetup[spellName].rd = self.db.char.spellSetup[spellName].rd or defaultReminder
			self.db.char.spellSetup[spellName].dd = durationDebuff
		end]]
	end
	if self.RefreshSpellOptions then
		self:RefreshSpellOptions()
	end
end

function SpellReminder:InstallAllSpells()
	self.bsoTmp = self.RefreshSpellOptions
	self.RefreshSpellOptions = nil -- allows faster addition of spells without calling BSO on each add.
	
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spell) then	break end
		self:InstallWatch(spell,rank)
		i = i + 1
	end
	--[[ still not found? try pets spellbook
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_PET)
		if (not spell) then	break end
		self:InstallWatch(spell,rank)
		i = i + 1
	end]]
	--[[ also talents???
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			self:InstallWatch(nameTalent,currRank)
	    end
	end]]
	self.RefreshSpellOptions = self.bsoTmp -- reinstate BSO
	self:RefreshSpellOptions()
end

function SpellReminder:UNIT_SPELLCAST_SENT(caster,name,rank,target)
-- if spells have target then ignore them here, they will be picked up by the aura processing
--	if target ~= nil and target ~= "" then return end -- comment this out, because not all spells have an aura

-- shadowfiend has a target, but has no aura.. we can 

--	if target == nil or target == "" or target == "player" or target == UnitName("player") then return end
	if caster ~= "player" then return end
	if target == nil or target == "" then target = UnitName("player") end
	local _,_,target = string.find(target,"([^-]+)")

	self:DebugPrint("Spellcast Started: "..caster.." -> "..target.." : "..name.." ("..rank..")")
	
	local info = self.db.char.spellSetup[name]
	if info == nil then return end
	if info.active ~= true then return end
	
	if self.spellTracker.casting == nil then self.spellTracker.casting = {} end
	local bt = ((target == nil or UnitIsFriend("player","target")) and "buff") or "debuff" --bartype
	table.insert(self.spellTracker.casting,{n=name, displayName=info.displayName, r=info.r, ["rank"]=rank, t=target, eventName="DURATION_ENDING_"..name..";"..target, c=info.c, barType=bt})
end

function SpellReminder:UNIT_SPELLCAST_STOP(caster,name,rank)
	if caster ~= "player" then return end
	if name == nil then return end
	if rank == nil then rank = "Rank 1" end

	self:DebugPrint("Spellcast Stopped: "..caster..":"..name..":"..rank)
if true then return end 
	table.foreach(self.spellTracker.casting,function (i,casting)
		if casting.n == name and casting.rank == rank then
			self.spellTracker.casting[i] = nil
		end
	end)
end

function SpellReminder:UNIT_SPELLMISS(caster,name,rank)
	self:DebugPrint("Spellcast Missed: "..caster..":"..name..":"..rank)
	if caster ~= "player" then return end

	table.foreach(self.spellTracker.active,function (i,spell)
		if spell.n == name and spell.rank == rank then
--			spell.canRemove = true
			self:OnDurationEnded(i,true)
			--self.spellTracker.active[i] = nil
		end
	end)
end

function SpellReminder:SPELL_MISS(t)
	table.foreach(self.spellTracker.active, function (eventName,info)
		if info.t == t.recipientName and info.n == t.abilityName then
--			info.canRemove = true
			self:OnDurationEnded(eventName,true)
		end
	end)
end

function SpellReminder:UNIT_SPELLCAST_SUCCEEDED(caster,name,rank)
	self:DebugPrint("Spellcast Finished: "..caster..":"..name..":"..rank)
	if caster ~= "player" then return end
	
	-- schedule an event for *padding* which ensures that a miss is detected
	local done = false
	for i,casting in pairs(self.spellTracker.casting) do
		if casting.n == name and casting.rank == rank then
			if done == false then -- make active first only, purge rest
				self:ScheduleEvent("CASTING_"..casting.n..";"..casting.t,self.FinalCastSuccess,0.5,self,casting)
				done = true
			end
			self.spellTracker.casting[i] = nil
		end
	end
	--self:CreateReminderBar(self.spellTracker.casting.eventName,name,info.d,info.r,self.spellTracker.casting.t,info.c)
end

function SpellReminder:FinalCastSuccess(castingInfo)
	self:DebugPrint("finalcast: "..castingInfo.n)
	if castingInfo == nil then return end
--	self:Print((self:IsEventRegistered("CASTING_"..castingInfo.n..";"..castingInfo.t) and "is registered") or "not registered")
--	if not self:IsEventRegistered("CASTING_"..castingInfo.n..";"..castingInfo.t) then return end
	if castingInfo.t == "player" or castingInfo.t == UnitName("player") and self:GetPlayerBuffDuration(castingInfo.n) ~= nil then --[[self:ProcessAuras("player")]]  return end
	
	buffDuration = self:GetDuration(castingInfo.n,castingInfo.rank)
	if buffDuration == nil then return end
	
	--castingInfo.canRemove = false -- changed to spellinfo.persistent
	castingInfo.persistent = self.db.char.spellSetup[castingInfo.n].persistent
	self:CreateReminderBar(castingInfo.eventName,castingInfo,buffDuration-0.5,castingInfo.r,castingInfo.c)
--	self:ProcessAuras("target")
end

function SpellReminder:RefreshAllBars()
	table.foreach(self.candybar.handlers,function(i,_)
		self.candybar:Update(i)
	end)
end

function SpellReminder:CreateReminderBar(e, castingInfo, duration, reminder, color, timeLeft)
	self:DebugPrint("CreateBar: "..castingInfo.n..": duration="..(duration or "no duration")..": reminder="..(reminder or "no reminder")..": timeleft="..(timeLeft or "none"))
	color = color or self.db.profile.defaultBarColor
	local target = castingInfo.t or UnitName("player")
	
	local setupInfo = self.db.char.spellSetup[castingInfo.n]
	if setupInfo and (setupInfo.selfOnly == true and target ~= UnitName("player")) then return end -- this spell is flagged as Self Only, but its being cast on another target, ignore bar creation.
	
	local targetGroupId = nil
	if setupInfo and setupInfo.allowCustomGroup == true then
--		if setupInfo.customGroup == nil or setupInfo.customGroup == -1 then self.candybar:UnregisterCandyBar(e) return end
		targetGroupId = setupInfo.customGroup
	elseif target == UnitName("player") then
--		if (self.db.profile.targetGroup_self == 0) then self.candybar:UnregisterCandyBar(e) return end
--		self:Print(self.db.profile.targetGroup_self)
--		if self.db.profile.targetGroup_self == nil or self.db.char.bargroups[tostring(self.db.profile.targetGroup_self)] == nil then self.db.profile.targetGroup_self = 1 end
		targetGroupId = self.db.profile.targetGroup_self
	elseif castingInfo.barType == "buff" or castingInfo.barType == nil then
--		if (self.db.profile.targetGroup_buff == 0) then self.candybar:UnregisterCandyBar(e) return end
--		if self.db.profile.targetGroup_buff == nil or self.db.char.bargroups[tostring(self.db.profile.targetGroup_buff)] == nil then self.db.profile.targetGroup_buff = 1 end
		targetGroupId = self.db.profile.targetGroup_buff
	elseif castingInfo.barType == "debuff" then
--		if (self.db.profile.targetGroup_debuff == 0) then self.candybar:UnregisterCandyBar(e) return end
--		if self.db.profile.targetGroup_debuff == nil or self.db.char.bargroups[tostring(self.db.profile.targetGroup_debuff)] == nil then self.db.profile.targetGroup_debuff = 1 end
		targetGroupId = self.db.profile.targetGroup_debuff
	end
	
	if targetGroupId == nil or targetGroupId < 1 then self.candybar:UnregisterCandyBar(e) return end
	castingInfo.initialGroup = targetGroupId
	
	-- build name
	local text = self.db.profile.textFormat
	text = string.gsub(text,"%%n",castingInfo.displayName or castingInfo.n)
	text = string.gsub(text,"%%r",castingInfo.rank or "")
	text = string.gsub(text,"%%t",target)
	if castingInfo.applications == 0 then castingInfo.applications = nil end
	text = string.gsub(text,"%%a",castingInfo.applications or "")
	text = string.gsub(text, "[(][)]", "") -- trim empty parenthesis
	text = string.gsub(text, "^%s*(.-)%s*$", "%1") -- trim whitespaces
	
	local alreadyExists, needsRefresh = self.candybar:IsCandyBarRegistered(e), false
	if alreadyExists then
		local _,totTime,elapsed = self.candybar:CandyBarStatus(e)
		local barTimeLeft = totTime - (elapsed or 9999)
		needsRefresh = (timeLeft == nil) or (barTimeLeft <= timeLeft-0.5) or (barTimeLeft >= timeLeft+0.5) or (barTimeLeft < reminder and timeLeft > reminder)-- or self.spellTracker.active[e].initialGroup ~= castingInfo.initialGroup) -- time left is > 1sec out of sync
	end 
--	if (alreadyExists and (timeLeft == nil or (timeLeft ~= nil and timeLeft > reminder+getOption("ttg")))) or alreadyExists == false then -- either bar doesnt exist, or its been refreshed then act as new // +1 on reminder is for padding, so we dont refresh the bar if its mid growth
	if (alreadyExists and needsRefresh) or (not alreadyExists) then -- either bar doesnt exist, or its been refreshed then act as new
		self:CancelScheduledEvent("GrowBar_"..e)
		self.candybar:RegisterCandyBar(e, duration, text)	
		self.candybar:RegisterCandyBarWithGroup(e,"ReminderCandy_"..targetGroupId)
		self.candybar:SetCandyBarScale(e,(self.db.char.bargroups[targetGroupId] and self.db.char.bargroups[targetGroupId].scale) or 1)
		if setupInfo and setupInfo.fade ~= nil then
			self.candybar:SetCandyBarFade(e,setupInfo.fade)
		end
		self.candybar:SetCandyBarTimeFormat(e, function ()
			local _,totaltime,elapsed = self.candybar:CandyBarStatus(e)
			local timeLeft = totaltime-elapsed
			if timeLeft > 60 then
				return string.format("%im", math.ceil(timeLeft / 60))
			elseif timeLeft <= 0.1 then
				return "--"
			else
				return string.format("%is", math.ceil(timeLeft))
			end
		end)
		self.candybar:SetCandyBarIcon(e,castingInfo.icon or self:GetTexture(castingInfo.n))
		self.candybar:SetCandyBarCompletion(e,self.OnDurationEnded,self,e)
		--self.candybar:StartCandyBar(e,true)

--		if (getOption("baroverride") == true) then
		self.candybar:SetCandyBarWidth(e,self.db.profile.barwidth)
		self.candybar:SetCandyBarHeight(e,self.db.profile.barheight)
		
		if self.db.profile.barfont then
			local f = self.candybar.handlers[e].frame
			f.timertext:SetFont(SpellReminder.sm:Fetch('font', self.db.profile.barfont),self.db.profile.barfontsize*0.9)
			f.text:SetFont(SpellReminder.sm:Fetch('font', self.db.profile.barfont),self.db.profile.barfontsize)
			
			local timertextwidth = self.db.profile.barfontsize * 3.6
			f.timertext:SetWidth(timertextwidth)
			f.text:SetWidth((self.db.profile.barwidth - timertextwidth) * .9)
		end
--		end
		
		local adjust = 0
		if timeLeft ~= nil then
			adjust = duration-timeLeft
			self.candybar:SetCandyBarTimeLeft(e,timeLeft)
		end
		self:ScheduleEvent(e, self.OnDurationEnding, duration-adjust-reminder, self, e)
--	elseif timeLeft ~= nil then  -- this bar already exists, but its time left is less than its reminder
--		candybar:SetCandyBarTimeLeft(e,timeLeft)
	end
	
	-- update trivial properties
	self.candybar:SetCandyBarText(e,text)
	self.candybar:SetCandyBarColor(e,color.r,color.g,color.b,1)
	self.candybar:SetCandyBarBackgroundColor(e,color.r,color.g,color.b,0.5)
	self.candybar:SetCandyBarTexture(e,SpellReminder.sm:Fetch('statusbar', self.db.profile.texture))
	
--	for _,suffix in pairs(self.spellSuffixes) do
--		castingInfo.n = string.gsub(castingInfo.n,suffix,"")
--	end
	if self.candybar.handlers[e].running ~= true then self.candybar:StartCandyBar(e,true) end
		
	self.spellTracker.active[e] = castingInfo
	
	table.foreach(self.anchors,function(i,anchor)
		self.candybar:UpdateCandyBarGroup("ReminderCandy_"..i)
	end)
	self:DebugPrint("create over:"..castingInfo.n)
--	candybar:UpdateGroup("SpellReminderNormal")
--	candybar:UpdateGroup("SpellReminderSelf")
--	candybar:UpdateGroup("SpellReminderEmphasis")
end

function SpellReminder:PLAYER_DEAD()
	table.foreach(self.spellTracker.active, function(eventName,info)
		if info ~= nil then
			self:OnDurationEnded(eventName,true)
--			self:CancelScheduledEvent(e)
--			self.candybar:SetCandyBarTime(e,0.09)
--			self.candybar:StopCandyBar(e,false)
		end
	end)
end

--  we must assume that on the death of this target, that all watched spells with this targets name apply to this death... 
function SpellReminder:COMBAT_DEATH(t)
	self:DebugPrint("death: "..t.recipientName)
	table.foreach(self.spellTracker.active, function (eventName,info)
		if (info.t == t.recipientName or (string.find(t.recipientName,info.t) ~= nil)) then -- call OnDurationEnded
		--	self:DebugPrint("ending: "..eventName)
			self:OnDurationEnded(eventName,true)
		end
	end)
end

function SpellReminder:SE_ITEM_AURA_LOST(name, rank, unknown)
	self:DebugPrint("SE_ITEM_AURA_LOST "..name)
	table.foreach(self.spellSuffixes, function(_,suffix)
		local checkName = name..suffix
		table.foreach(self.spellTracker.active, function (eventName,info)
			if info.n == checkName and (info.t == nil or info.t == "" or info.t == "player" or info.t == UnitName("player")) then -- call OnDurationEnded
				self:OnDurationEnded(eventName,true)
				return
			end
		end)
	end)
end

function SpellReminder:SE_AURA_LOST(unit, name, count, icon, rank, duration)
	if unit == "target" then return end -- dont lose bars when switching target
	self:DebugPrint("SE_AURA_LOST "..name)
	table.foreach(self.spellSuffixes, function(_,suffix)
		local checkName = name..suffix
		table.foreach(self.spellTracker.active, function (eventName,info)
			if info.n == checkName and ((info.t == nil or info.t == "") or (info.t == unit or info.t == UnitName(unit))) then -- call OnDurationEnded
				self:OnDurationEnded(eventName,true)
				return
			end
		end)
	end)
end

function SpellReminder:UNIT_SPELLCAST_CHANNEL_STOP(unit, spellname, spellrank)
	if unit ~= "player" then return end
	self:DebugPrint("channel_stop: "..spellname)
	self:OnDurationEnded("DURATION_ENDING_"..spellname..";"..UnitName(unit),true)
end
--[[
--function SpellReminder:AURA_LOST(t)
	self:DebugPrint("AURA_LOST "..t.abilityName)
	table.foreach(self.spellTracker.active, function (eventName,info)
		if info.n == t.abilityName and (info.t == nil or t.recipientName == info.t or info.t == "") then -- call OnDurationEnded
			self:OnDurationEnded(eventName)
		end
	end)
end

--function SpellReminder:AURA_GAIN(t)
	self:UNIT_SPELLCAST_SENT("player",t.abilityName)
	self:UNIT_SPELLCAST_SUCCEEDED("player",t.abilityName)
end

--function SpellReminder:PLAYER_REGEN_ENABLED()
if true then return end
	table.foreach(self.spellTracker.active, function (eventName,info)
		if info.t and info.t ~= "" then -- call OnDurationEnded
			self:OnDurationEnded(eventName,true)
		end
	end)
end
]]
function SpellReminder:OnDurationEnded(eventName,quiet)
	self:DebugPrint("OnDurationEnded: "..eventName)
	local _,_,spellName,spellTarget = string.find(eventName,"DURATION_ENDING_(.+);(.*)")	
	if spellName == nil then return end
	self:CancelScheduledEvent("CASTING_"..spellName..";"..spellTarget)

	local castingInfo = self.spellTracker.active[eventName]
	if castingInfo == nil or castingInfo.persistent then return end
	
	self:CancelScheduledEvent(eventName)
	self.spellTracker.active[eventName] = nil
	
	local setupInfo = self.db.char.spellSetup[spellName]
	if not setupInfo then return end

	local name = (self.spellTracker.active[eventName] and self.spellTracker.active[eventName].n) or "Spell"
	local target = (self.spellTracker.active[eventName] and " ("..self.spellTracker.active[eventName].t..")") or ""
	
	if not quiet and (self.db.profile.textWarnings == "Both" or self.db.profile.textWarnings == "Expired Only") then
		self:Pour(name..target.." has EXPIRED!",1,1,1,nil,nil,nil,true)
	end

	if setupInfo.fade == 0 then self.candybar:UnregisterCandyBar(eventName) return end
	
	self.candybar:SetCandyBarTimeLeft(eventName,0)
	
	local regdGroup = self:GetRegisteredGroup(eventName)	
	if regdGroup and self.db.char.bargroups[regdGroup].emphasise == true then
		self:GrowCandy(eventName)
	end

	self.candybar:Update(eventName)
end

function SpellReminder:OnDurationEnding(eventName,quiet)
	local name = (self.spellTracker.active[eventName] and self.spellTracker.active[eventName].n) or "Spell"
	local target = (self.spellTracker.active[eventName] and " ("..self.spellTracker.active[eventName].t..")") or ""
	
	local reg, t, e, r = self.candybar:CandyBarStatus(eventName)
	if not reg then return end

	local _,_,spellName,spellTarget = string.find(eventName,"DURATION_ENDING_(.+);(.*)")
	local setupInfo = self.db.char.spellSetup[spellName]
	
	if not quiet then
		local soundfile = self.db.profile.audioWarnings
		if setupInfo and setupInfo.allowCustomSound and setupInfo.customSound then soundfile = setupInfo.customSound end
		PlaySoundFile(SpellReminder.sm:Fetch('sound', soundfile))
		if (self.db.profile.textWarnings == "Both" or self.db.profile.textWarnings == "Expiring Only") then
			self:Pour(name..target.." over in "..math.floor(t-e-1).." seconds!",1,1,1,nil,nil,nil,true)
		end
	end
	
	local regdGroup = self:GetRegisteredGroup(eventName)
	
	if regdGroup and self.db.char.bargroups[regdGroup].emphasise == true then
		self:GrowCandy(eventName)
	end
end

function SpellReminder:GetRegisteredGroup(eventName)
	local regdGroup = nil
	for k,v in pairs(self.anchors) do
		if self.candybar:IsCandyBarRegisteredWithGroup(eventName,"ReminderCandy_"..k) then
			regdGroup = k
			break
		end
	end
	return regdGroup
end

function SpellReminder:GetTexture(name)
	local i = 1
	while true do
		local nm = GetSpellName(i, BOOKTYPE_SPELL)
		if not nm then break
		elseif nm == name then
			return GetSpellTexture(i, BOOKTYPE_SPELL)
		end
		i = i + 1
	end
	-- still not found? try pets spellbook
	local i = 1
	while true do
		local nm = GetSpellName(i, BOOKTYPE_PET)
		if not nm then break
		elseif nm == name then
			return GetSpellTexture(i, BOOKTYPE_PET)
		end
		i = i + 1
	end
	
	if true then return nil end
	
	-- finally, do the talents
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			if nameTalent == spellName and currRank > 0 then
				local buff, debuff = self:FindDurationInTip(tiptext)
				return buff, debuff, currRank
			end
	    end
	end
end

function SpellReminder:GrowCandy(id)
	self:DebugPrint("Grow Candy "..id)
	--self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,GetTime()+self.db.profile.ttg)
	self.candybar:SetCandyBarScale(id,self.db.char.bargroups[self:GetAnchorByIdent("emphasis")].scale)
	self.candybar:RegisterCandyBarWithGroup(id,"ReminderCandy_"..self:GetAnchorByIdent("emphasis"))
end
--[[ function SpellReminder:GrowBar(id, stopTime)
	if not self.candybar:IsCandyBarRegistered(id) then return end
	if GetTime() > stopTime then
		self.candybar:SetCandyBarScale(id,self.db.char.bargroups[self:GetAnchorByIdent("emphasis")].scale)
		self.candybar:RegisterCandyBarWithGroup(id,"ReminderCandy_"..self:GetAnchorByIdent("emphasis"))
		return
	end
	local now = GetTime()
	local cbscale = self.candybar:GetCandyBarEffectiveScale(id)
	local scale = (self.db.char.bargroups["emphasis"].scale - cbscale) * (1 - ((stopTime - now) / self.db.profile.ttg))

	self.candybar:SetCandyBarScale(id,cbscale + scale)
	local centerX, centerY = self.candybar:GetCandyBarCenter(id)
	local effscale = UIParent:GetEffectiveScale()
	
	local posX = ((self.db.char.bargroups["emphasis"].position.x) - (centerX)) * (1-((stopTime - now) / self.db.profile.ttg)) 
	local posY = ((self.db.char.bargroups["emphasis"].position.y) - (centerY)) * (1-((stopTime - now) / self.db.profile.ttg))

	local point, rframe, rpoint = self.candybar:GetCandyBarPoint(id)
	self.candybar:SetCandyBarPoint(id, point, rframe, rpoint, posX, posY)
--	candybar:SetCandyBarPoint(id, point, rframe, rpoint, posX/effscale, posY/effscale)
	
	self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,stopTime)
end
]]
function SpellReminder:BarExists(spellName)
	for e, info in pairs(self.spellTracker.active) do
		if info.n == spellName then
			return true
		end
	end
	return false
end
--[[function SpellReminder:GrowBar(id, stopTime)
	if not candybar:IsCandyBarRegistered(id) then return end
	if GetTime() > stopTime then
		candybar:SetCandyBarScale(id,getOption("stopScale"))
		candybar:RegisterCandyBarWithGroup(id,"SpellReminderEmphasis")
		return
	end
	local now = GetTime()
	local scale = (getOption("stopScale") - getOption("startScale")) * (1 - ((stopTime - now) / getOption("ttg")))

	candybar:SetCandyBarScale(id,getOption("startScale") + scale)
	local effscale = UIParent:GetEffectiveScale()
	
	local posX = ((self.db.profile.barposition["emphasis"].x) - (self.db.profile.barposition["normal"].x)) * (1-((stopTime - now) / getOption("ttg"))) 
	local posY = ((self.db.profile.barposition["emphasis"].y) - (self.db.profile.barposition["normal"].y)) * (1-((stopTime - now) / getOption("ttg")))
	self:Print(posX.." : "..posY)
	local point, parent, anchor, x, y = self.normalAnchor:GetPoint()
	candybar:SetCandyBarPoint(id, point, parent, anchor, posX*effscale, (posY * -1)*effscale)
	
	self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,stopTime)
end]]

function SpellReminder:GetPlayerBuffDuration(spellName)
	local i = 1
	while (UnitBuff("player",i) ~= nil) do
		name, rank, iconTexture, count, duration, timeLeft =  UnitBuff("player", i)
		if name == spellName and duration ~= nil then return duration end
		i = i + 1
	end
	local i = 1
	while (UnitBuff("pet",i) ~= nil) do
		name, rank, iconTexture, count, duration, timeLeft =  UnitBuff("pet", i)
		if name == spellName and duration ~= nil then return duration end
		i = i + 1
	end
end

local tt = AceLibrary("Gratuity-2.0")   
function SpellReminder:GetDuration(spellName, chkRank)
--[[	table.foreach(staticTimes , function(spell,info)
		if spellName == spell and toreturn == nil then
			toreturn = { info.durationBuff, info.durationDebuff, info.rank }
		end
	end)
	if toreturn ~= nil then return toreturn[1], toreturn[2], toreturn[3], toreturn[4] end
]]

	for _,suffix in pairs(self.spellSuffixes) do
		local toreturn = nil
		local lastRank = nil
		local i = 1
		while true do
			local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
			if (not spell) then	break end
			if spell == spellName..suffix then
				if (chkRank == nil and (lastRank == nil or rank > lastRank)) or (rank == chkRank) then
					lastRank = rank
					tt:SetSpell(i,BOOKTYPE_SPELL)
					local tiptext = self:GetFullTipText(tt)
					local buff = self:FindDurationInTip(tiptext)
					toreturn = { buff, rank }
				end
			end
			i = i + 1
		end
		if toreturn ~= nil then return toreturn[1], toreturn[2] end
	end
	--[[ still not found? try pets spellbook
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_PET)
		if (not spell) then	break end
		if spell == spellName then
			if (chkRank == nil and (lastRank == nil or rank > lastRank)) or (rank == chkRank) then
				lastRank = rank
				tt:SetSpell(i,BOOKTYPE_PET)
				local tiptext = self:GetFullTipText(tt)
				local buff, debuff = self:FindDurationInTip(tiptext)
				toreturn = { buff, debuff, rank }
			end
		end
		i = i + 1
	end
	if toreturn ~= nil then return toreturn[1], toreturn[2], toreturn[3], true end
	]]
	--[[ finally, do the talents
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			if nameTalent == spellName and currRank > 0 then
				tt:SetTalent(t,i)
				local tiptext = self:GetFullTipText(tt)
				local buff, debuff = self:FindDurationInTip(tiptext)
				return buff, debuff, currRank
			end
	    end
	end]]

	return nil
end

function SpellReminder:FindDurationInTip(tiptext)
	local pre = {"for","over","lasts","up to"}
	local post = {"sec","min","hour"}
	local durationBuff = nil
	local durationDebuff = nil
	local newDur = nil
	table.foreach(pre, function(_,preVal) -- loop through prefixes
		preVal = string.lower(preVal)
		table.foreach(post, function(_,postVal)  -- loop through suffixes
			postVal = string.lower(postVal)
			for newDur in string.gmatch(string.lower(tiptext),preVal.." (%d+) "..postVal) do
				newDur = tonumber(newDur)
				if newDur ~= nil then
					if postVal == "min" then
						newDur = newDur * 60
					elseif postVal == "hour" then
						newDur = newDur * 60 * 60
					end
					if (durationBuff == nil) then
						durationBuff = newDur
					elseif (newDur > durationBuff) then
						durationDebuff = durationBuff
						durationBuff = newDur
					end
				end
			end
		end)
	end)
	
	return tonumber(durationBuff), tonumber(durationDebuff)
end

function SpellReminder:GetFullTipText(tt)
	local fullText = ""
	for i=1,tt:NumLines() do
		fullText = fullText..tt:GetLine(i)
	end
	return fullText
end

function SpellReminder:DebugPrint(text)
	if not self.db.profile.debugmode then return end
	self:Print(text)
end

function tcopy(from,to)   -- "to" must be a table (possibly empty)
	if type(from)~="table" then return nil end
	if to == nil then to = {} end
	for k,v in pairs(from) do
		if(type(v)=="table") then
			to[k] = tcopy(v)
		else
			to[k] = v
		end
	end
	
	return to
end
 